#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Mon Feb  5 10:56:22 2018

@author: andreucasas
"""

import os
import re
import urllib
data_dir = '/Users/andreucasas/Desktop/repos/images_as_data_DATA/'
root = 'http://andreucasas.com/images/'

experiments = os.listdir(data_dir)
experiments = [x for x in experiments if x not in ['.DS_Store', 'data']]

for exp in experiments:
    print('Working on experiment: %s...'%(exp.upper()))
    exp_dir = '%s%s/'%(data_dir, exp)
    train_str = open('%strain.txt'%(exp_dir), 'rb').read()
    test_str = open('%stest.txt'%(exp_dir), 'rb').read()
    
    train_list = [x.split('/')[7] for x in train_str.split('\n') if len(x) > 0]
    test_list = [x.split('/')[7] for x in test_str.split('\n') if len(x) > 0]
    
    train_imgs = [x.split()[0] for x in train_list]
    train_labels = [x.split()[1] for x in train_list]

    test_imgs = [x.split()[0] for x in test_list]
    test_labels = [x.split()[1] for x in test_list]
    
    new_exp_dir = '%sdata/%s/'%(data_dir, exp.split('_')[0])
    if not os.path.exists(new_exp_dir):
        os.makedirs(new_exp_dir)
        os.makedirs('%strain'%(new_exp_dir))
        os.makedirs('%strain/negative'%(new_exp_dir))
        os.makedirs('%strain/positive'%(new_exp_dir))
        os.makedirs('%stest'%(new_exp_dir))
        os.makedirs('%stest/negative'%(new_exp_dir))
        os.makedirs('%stest/positive'%(new_exp_dir))

    print('... downloading training images ...')    
    for i in range(len(train_labels)):
        fname = train_imgs[i]
        if train_labels[i] == '0':
            img_path = '%strain/negative/%s'%(new_exp_dir, fname)
        else:
            img_path = '%strain/positive/%s'%(new_exp_dir, fname)
        urllib.urlretrieve('%s%s'%(root, train_imgs[i]), img_path)

    print('... downloading testing images ...')    
    for i in range(len(test_labels)):

        fname = test_imgs[i]
        if test_labels[i] == '0':
            img_path = '%stest/negative/%s'%(new_exp_dir, fname)
        else:
            img_path = '%stest/positive/%s'%(new_exp_dir, fname)
        urllib.urlretrieve('%s%s'%(root, test_imgs[i]), img_path)

